﻿/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

using System;


//using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Collections;
using Microsoft.WindowsMobile.Samples.Location;
using Microsoft.WindowsCE.Forms;

using Microsoft.WindowsMobile.Status;

namespace WMobileMaps
{

    public partial class form1 : Form
    {
        int dispWidth, dispHeight;
        
        int zoom;   //
        int userzoom; // hodnoty: 1 = 100%,2 = 200%;
        int userzoombits = 0; // binary shift userzoom - userzoom==1 => userzoombits = 0; userzoom==2 => userzoombits = 1;

        const int ZOOM_MAX = 0;
        const int ZOOM_MIN = 17;
        const int earths_average_meridional_radius = 6367449; // [m]
        const string TILES_DIR_MENU_PREFIX = "Tiles: ";

        int tilesWidth, tilesHeight;
        ScreenOrientation orientationAtApplicationStart;

        int tilex, tiley;
        string googlemapsRootPath;
        string googlemapsMapsRootPath;
        string missingTile;
        string gpsMarkerLoFile, gpsMarkerHiFile;  // gps markers for hires and lowres
        
        const string fileLastUsedMap = "lastmap.txt"; // getMapsRootPath() + fileLastUsedMap
        string mapDirsCurrent;
        public const string sqliteTilesRepository = "tilerepository.db";
        // file has following structure:
        //  siezOf(sqliteTilesRepository):layerid1:layerid2:layerid3...
        public const string sqliteTilesRepositoryLayers = "layers.txt";
        //const string mapDirsCurrent_DEFULT = "map";
        // not implemented yeat: format of stored waypoint in pixels: ("px:",wayPointText,":",zoom.ToString(), ":", coordX.ToString(), ":", coordY.ToString(), ":", Color );
        // format of stored waypoint: ("gps;", type, ";",latitude.ToString(), ";", longitude.ToString(), ";", Timestamp, ";", Color, ";", wayPointName, ";", Note );
        const string fileWayPoints = "waypoints.txt"; // is created as: getSelectedTilesPath() + "\\" + fileWayPoints
        const char wayPointSep = ';';
        // format of stored position: ("px:", zoom.ToString(), ":", coordX.ToString(), ":", coordY.ToString(), ":", tilesDirsCurrent);
        const string fileLastUsedPosition = "lastposition.txt"; // is created as: getSelectedTilesPath() + "\\" + fileLastUsedPosition
        //string tilesDirsCurrent = "tiles";
        //ArrayList tilesDirs;
        Hashtable tilesDirsMenuItems;

        bool bLowResDisplay; // do we have a low res display?

        int mousePosX, mousePosY; // helper vars for mouse moving the map
        int mouseDeltaX, mouseDeltaY; // helper vars promenne - how much the map was moved
        int ofsx, ofsy; // used for drawing tiles
        int coordX, coordY; // coords of the middle of the display - in pixels

        bool drawMouseCoord; // flag - if true => draw the box with the coords of thou mouse pointer / used for debugging
        bool flagMovingTheMouse; // flag - if true => map is being moved
        bool flagPictureBox1Click;
        bool flagShowGPSCoords;
        bool flagDrawWayPoints;
        bool flagDrawAllWayPoints;
        const String defaultWPType = "U";
        String selectedWPTypes;   // string with selected names of one letter waypoint types
        String allWPTypes; // contans one letter wp types of all types. Initialized in readStoredWayPoints()

        //System.Windows.Forms.PictureBox pictureMarkerGPS;
        bool flagStickToGPSCoords; // if true - stick the middle of the map to the GPS coords
        double gpsLatitude, gpsLongitude;
        int gpsLatitudePix, gpsLongitudePix;
        bool flagGPSLatitudeValid;
        bool flagGPSLongitudeValid;
        int rulerWidth;    //size of ruler
        int pictureBoxGPSHalfWidth, pictureBoxGPSHalfHeight;  // half size of the GPS marker, for offset position
        PictureBoxGPS pictureBoxGPS = null;

        Bitmap bitmapBuffer = null; // buffer. used for "doubleBuffering"

        int tilesCacheSize = 64;
        Hashtable tilesCache;  // mapping String fileName - Bitmapa
        SortedList tilesTimestampCache; // mapping long timestamp - String filename
        Bitmap tileNotFound;

        private Gps gps;

        // list of all waypoints
        ArrayList waypoints;

        ITileRepos tilesRepository;

        public string GooglemapsRootPath
        {
            get
            {
                return googlemapsRootPath;
            }
        }

        public form1()
        {
            InitializeComponent();

            this.WindowState = FormWindowState.Maximized;

            //string googlemapsRootPath = @"\Storage Card\wmgooglemaps";
            // set paths:
            string strAssmPath = System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase;
            googlemapsRootPath = strAssmPath.Substring(0, strAssmPath.LastIndexOf(@"\"));
            googlemapsMapsRootPath = googlemapsRootPath + @"\maps";
            missingTile = googlemapsRootPath + @"\missing.png";
            gpsMarkerHiFile = googlemapsRootPath + @"\gpsmarkerhi.png";
            gpsMarkerLoFile = googlemapsRootPath + @"\gpsmarkerlo.png";

            drawMouseCoord = false;
            zoom = 15;
            userzoom = 1;
            userzoombits = 0;
            tilesWidth = 256;
            tilesHeight = 256;

            bLowResDisplay = false;
            rulerWidth = tilesWidth;
            bgps.BackColor = System.Drawing.Color.LightGray;
            bgps.Enabled = false;
            flagStickToGPSCoords = false;

            flagDrawWayPoints = false;
            flagDrawAllWayPoints = false;
            selectedWPTypes = "";

            flagShowGPSCoords = false;

            gps = new Gps();


            flagPictureBox1Click = false;



            // coords of the Prague
            //coordX = (17 * 1024 + 287) * tilesWidth;
            //coordY = (10 * 1024 + 860) * tilesHeight;
            //Praha - strelecky ostrov: N50.08145, E14.4100
            // latitude N50, long E14
            // gps debug: -122.186451666; 47.6336299999
            //GPScoord_to_plaincoord(47.6336299999, -122.186451666, zoom, out coordX, out coordY); // gpsdebug - textak ze samplu od MS
            
            tilesDirsMenuItems = new Hashtable();
            //tilesDirsCurrent = "";
            tilesCacheSize = 64;
            GPScoord_to_plaincoord(50.076, 14.444, zoom, out coordX, out coordY);   // praha

            waypoints = new ArrayList();
            initScreenDimensions();

            flagGPSLatitudeValid = false;
            flagGPSLongitudeValid = false;

            FileStream src = new FileStream(missingTile, FileMode.Open);
            tileNotFound = new Bitmap(src);
            src.Close();
            
            initMap();
            if (!tilesRepository.isInitialized())
            {
                show_dialog_select_map_dir();
            }
        }

        private String validateMapDirsCurrent(String currentMapDir)
        {
            // find first directory in maps directory

            // do we have maps directory ?
            if (!Directory.Exists(googlemapsMapsRootPath))
            {
                throw new RepositoryNotExistsException("Directory '" + googlemapsMapsRootPath + "' doesn't exist.");
            }


            if (currentMapDir != null)
            {   
                // if we have existing map, does it exist ?
                if (Directory.Exists(googlemapsMapsRootPath + "\\" + currentMapDir))
                {
                    return currentMapDir;
                }
            }

            // we don't have map get first available map
            string[] directories = Directory.GetDirectories(googlemapsMapsRootPath);
            if (directories.Length > 0)
            {
                int i = directories[0].LastIndexOf('\\');
                String directoryString = directories[0].Substring(directories[0].LastIndexOf('\\') + 1);

                return directoryString;
            }

            throw new RepositoryNotExistsException("No map available in '" + googlemapsMapsRootPath + "'.");
        }

        private void initMap()
        {
            if (mapDirsCurrent == null)
            {
                readStoredMap();

                // validate if we have existing directory among maps
                try
                {
                    mapDirsCurrent = validateMapDirsCurrent(mapDirsCurrent);
                }
                catch (RepositoryNotExistsException e)
                {
                    MessageBox.Show( e.ToString() );
                    throw e;
                }
            }
            else
            {
                writeMap();
            }

            try
            {
                tilesRepository = TileReposFactory.getTileRepository(this);
            }
            catch (RepositoryNotInitializedException e)
            {  
                MessageBox.Show( e.ToString() );
                throw e;
            }

            if (tilesRepository.isInitialized())
            {
                readStoredPosition();
                readStoredWayPoints();
                fillLayerNames();
            }
            initTilesCache();
            setbplusminusLabels();
        }

        private void initTilesCache()
        {
            tilesCache = new Hashtable(tilesCacheSize);
            tilesTimestampCache = new SortedList(tilesCacheSize);
        }

        public string getRootPath()
        {
            return googlemapsRootPath;
        }

        public string getMapsRootPath()
        {
            return googlemapsMapsRootPath;
        }

        public string getSelectedMapPath()
        {
            if (mapDirsCurrent == null)
            {
                throw new NullReferenceException();
            }
            return String.Concat(googlemapsMapsRootPath + "\\" + mapDirsCurrent);
        }

        private void initScreenDimensions()
        {
            pictureBox1.Width = this.Width;
            pictureBox1.Height = this.Height;
            dispWidth = pictureBox1.Width;
            dispHeight = pictureBox1.Height;
            if (bitmapBuffer != null)
            {
                bitmapBuffer.Dispose();
            }
            bitmapBuffer = new Bitmap(3 * dispWidth, 3 * dispHeight);

            if ((this.Width < 300) || (this.Height < 300))
            {
                bLowResDisplay = true;
                rulerWidth = tilesWidth >> 1;

                if (pictureBoxGPS == null)
                {
                    pictureBoxGPS = new PictureBoxGPS(gpsMarkerLoFile);
                    this.Controls.Add(pictureBoxGPS);
                    pictureBoxGPS.Visible = false;
                    pictureBoxGPS.BringToFront();
                }
            }
            else
            {
                bLowResDisplay = false;
                rulerWidth = tilesWidth;

                if (pictureBoxGPS == null)
                {
                    pictureBoxGPS = new PictureBoxGPS(gpsMarkerHiFile);
                    this.Controls.Add(pictureBoxGPS);
                    pictureBoxGPS.Visible = false;
                    pictureBoxGPS.BringToFront();
                }
            }

            pictureBoxGPSHalfWidth = (pictureBoxGPS.Width - 1) >> 1;
            pictureBoxGPSHalfHeight = (pictureBoxGPS.Height - 1) >> 1;
            pictureBoxGPS.BackColor = System.Drawing.Color.Blue;
            pictureBoxGPS.Location = new System.Drawing.Point(dispWidth / 2 - pictureBoxGPSHalfWidth, dispHeight / 2 - pictureBoxGPSHalfHeight);


            if (SystemSettings.ScreenOrientation == ScreenOrientation.Angle0) 
            { 
                // potrait
                bplus.Location = new System.Drawing.Point(5, dispHeight - bplus.Height - 5);
                bminus.Location = new System.Drawing.Point(1+bplus.Location.X + bplus.Width, dispHeight - bminus.Height - 5);
                buserzoom.Location = new System.Drawing.Point(1 + bminus.Location.X + bminus.Width, dispHeight - buserzoom.Height - 5);
                bgps.Location = new System.Drawing.Point(15 + buserzoom.Location.X + buserzoom.Width, dispHeight - bgps.Height - 5);
                bgpspanelswitch.Location = new System.Drawing.Point(1 + bgps.Location.X + bgps.Width, dispHeight - bgpspanelswitch.Height - 5);
                bshowwaypoints.Location = new System.Drawing.Point(1 + bgpspanelswitch.Location.X + bgpspanelswitch.Width, dispHeight - bshowwaypoints.Height - 5);
            }
            else 
            {
                // landscape
                bplus.Location = new System.Drawing.Point(dispWidth - bplus.Width - 5, 5);
                bminus.Location = new System.Drawing.Point(dispWidth - bminus.Width - 5, 1 + bplus.Location.Y + bplus.Height);
                buserzoom.Location = new System.Drawing.Point(dispWidth - buserzoom.Width - 5, 1 + bminus.Location.Y + bminus.Height);
                bgps.Location = new System.Drawing.Point(dispWidth - bgps.Width - 5, 15 + buserzoom.Location.Y + buserzoom.Height);
                bgpspanelswitch.Location = new System.Drawing.Point(dispWidth - bgpspanelswitch.Width - 5, 1 + bgps.Location.Y + bgps.Height);
                bshowwaypoints.Location = new System.Drawing.Point(dispWidth - bshowwaypoints.Width - 5, 1 + bgpspanelswitch.Location.Y + bgpspanelswitch.Height);
            }

        }


        private void readStoredPosition()
        {
            string[] parts;
            int cx, cy, zm;

            string filepath = String.Concat(getSelectedMapPath() + "\\" + fileLastUsedPosition);
            if (!File.Exists(getSelectedMapPath() + "\\" + fileLastUsedPosition ))
            {
                // default position - prague
                zm = 16;
                cx = 276;
                cy = 173;
                tilesRepository.setTilesLayer();

                return;
            }

            // if we have file lastposition.txt - read it
            try
            {
                // Create an instance of StreamReader to read from a file.
                // The using statement also closes the StreamReader.
                using (StreamReader sr = new StreamReader(filepath))
                {
                    String line;
                    // Read and display lines from the file until the end of 
                    // the file is reached.
                    if ((line = sr.ReadLine()) != null)
                    {
                        parts = line.Trim().Split(':');
                        if (parts.Length != 5) throw new IOException("StoredPosition doesn't contain 5 pieces of data.");
                        if (parts[0] != "px") throw new IOException("StoredPosition px is not \'px\'.");

                        zm = Int32.Parse(parts[1]);
                        cx = Int32.Parse(parts[2]);
                        cy = Int32.Parse(parts[3]);
                        try
                        {
                            tilesRepository.setTilesLayer(parts[4]);
                        }
                        catch (Exception)
                        {
                            // well try to set any layer
                            tilesRepository.setTilesLayer();
                        }

                        // if exception was not rised:
                        coordX = cx;
                        coordY = cy;
                        zoom = zm;
                    }
                    else 
                    {
                        throw new IOException("File " + filepath + " doesn't contain data.");
                    }
                }
            }
            catch (Exception e)
            {
                // Let the user know what went wrong.
                MessageBox.Show("The file error: " + filepath + "\n" + e.ToString() + e.StackTrace);
            }
        }

        private void createEmptyWayPointsFile()
        {
            string dirpath = getSelectedMapPath();
            string filepath = String.Concat(dirpath + "\\" + fileWayPoints);

            if (Directory.Exists(dirpath))
            {
                try
                {
                    using (StreamWriter outfile = new StreamWriter(filepath))
                    {
                        // format of stored waypoint: ("gps;", type, ";",latitude.ToString(), ";", longitude.ToString(), ";", Timestamp, ";", Color, ";", wayPointName, ";", Note );
                        string pos = "#gps;<type>;<latitude>;<longitude>;<timestamp>;<color>;<wayPointName>;<Note>";
                        outfile.Write(pos);
                    }
                }
                catch (Exception exc)
                {
                    MessageBox.Show("Unable to create waypoints file.\n" + exc.ToString() + exc.StackTrace);
                }
            }
        }

        private void readStoredWayPoints()
        {
            waypoints = new ArrayList();
            string filepath = String.Concat(getSelectedMapPath() + "\\" + fileWayPoints);
            string waypointsList = "";
            string separator = "";
            try
            {
                if (!File.Exists(filepath))
                {
                    createEmptyWayPointsFile();
                }

                // Create an instance of StreamReader to read from a file.
                // The using statement also closes the StreamReader.
                allWPTypes = "";
                using (StreamReader sr = new StreamReader(filepath))
                {
                    String line = "";
                    // Read and display lines from the file until the end of 
                    // the file is reached.

                    // format of stored waypoint: ("gps;", type, ";",latitude.ToString(), ";", longitude.ToString(), ";", Timestamp, ";", Color, ";", wayPointName, ";", Note );
                    while ((line = sr.ReadLine()) != null)
                    {
                        try
                        {
                            if (line.Trim().Substring(0, 1).Equals("#"))
                            {
                                // mame komentar
                                continue;
                            }

                            string[] parts;
                            //int cx, cy, zm;
                            double lat, lon;
                            string name, note, color, tstamp;
                            string wptype;

                            parts = line.Trim().Split(wayPointSep);
                            if (parts.Length != 8) throw new IOException("StoredPosition doesn't contain 8 pieces of data.");
                            if (parts[0] != "gps") throw new IOException("StoredPosition gps is not \'gps\'.");

                            name = parts[6];
                            note = parts[7];
                            tstamp = parts[4];
                            lat = Double.Parse(parts[2]);
                            lon = Double.Parse(parts[3]);
                            color = parts[5];
                            wptype = parts[1];
                            // add wptype to allWayPoints if not exists
                            //int ret = allWPTypes.IndexOf(wptype.Substring(0, 1).ToUpper());
                            if (wptype.Length == 0)
                            {
                                wptype = defaultWPType.Substring(0, 1).ToUpper();
                            }
                            else
                            {
                                wptype = wptype.Substring(0, 1).ToUpper();
                            }
                            if (allWPTypes.IndexOf(wptype.Substring(0, 1).ToUpper()) == -1)
                            {
                                allWPTypes = allWPTypes + wptype;
                            }

                            // if exception was not rised:

                            WayPoint wp = new WayPoint(wptype, name, note, lat, lon, color, tstamp);
                            waypoints.Add(wp);

                            waypointsList = String.Concat(waypointsList, separator, name);
                            separator = ", ";


                        }
                        catch (Exception)
                        {
                            MessageBox.Show(String.Concat("readStoredWayPoints: Invalid format in line: ", line));
                        }
                    }
                }
            }
            catch (Exception e)
            {
                // Let the user know what went wrong.
                MessageBox.Show("The file error: " + filepath + "\n" + e.ToString() + e.StackTrace);
            }

            recountWaypointsCoords();
            if (waypoints.Count == 0)
            {
                MessageBox.Show("There are no wayps for selected map.");
            }
            else
            {
                if (waypoints.Count == 1)
                    MessageBox.Show("There is " + waypoints.Count.ToString() + " wayp. \n" + waypointsList);
                else
                    MessageBox.Show("There are " + waypoints.Count.ToString() + " wayps. \n" + waypointsList);
            }
              
        }

        private void writeMapPosition()
        {
            // save to file:
            string dirpath = String.Concat(getSelectedMapPath());
            if (Directory.Exists(dirpath))
            {
                try
                {
                    using (StreamWriter outfile =
                        new StreamWriter(dirpath + "\\" + fileLastUsedPosition))
                    {
                        string pos = string.Concat("px:", zoom.ToString(), ":", coordX.ToString(), ":", coordY.ToString(), ":", tilesRepository.getLayerTextID());
                        outfile.Write(pos);
                    }
                }
                catch (Exception exc)
                {
                    MessageBox.Show("Unable to store current position.\n" + exc.ToString() + exc.StackTrace);
                }
            }
        }

        private void readStoredMap()
        {
            string filepath = String.Concat(getRootPath() + "\\" + fileLastUsedMap);
            try
            {
                // Create an instance of StreamReader to read from a file.
                // The using statement also closes the StreamReader.
                if (!System.IO.File.Exists(filepath))
                {
                    return;
                }
                else
                {
                    using (StreamReader sr = new StreamReader(filepath))
                    {
                        String line;
                        // Read and display lines from the file until the end of 
                        // the file is reached.
                        if ((line = sr.ReadLine()) != null)
                        {

                            mapDirsCurrent = line.Trim();
                            if (!Directory.Exists(getSelectedMapPath()))
                            {
                                //mapDirsCurrent = mapDirsCurrent_DEFULT;
                                //MessageBox.Show(String.Concat("File fileLastUsedMap contains invalid map dir '" + line.Trim() + "'"));
                                mapDirsCurrent = null;
                                return;
                            }
                        }
                        else
                        {
                            //throw new IOException("File " + filepath + " doesn't contain data.");
                            mapDirsCurrent = null;
                            return;
                        }
                    }
                }
            }
            catch (Exception e)
            {
                // Let the user know what went wrong.
                //mapDirsCurrent = mapDirsCurrent_DEFULT;
                MessageBox.Show("Error: " + filepath + "\n" + e.ToString() + e.StackTrace);
            }
        }

        private void writeMap()
        {
            // save to file:
            string dirpath = getRootPath();
            if (Directory.Exists(dirpath))
            {
                try
                {
                    using (StreamWriter outfile =
                        new StreamWriter(dirpath + "\\" + fileLastUsedMap))
                    {
                        string pos = string.Concat(mapDirsCurrent);
                        outfile.Write(pos);
                    }
                }
                catch (Exception exc)
                {
                    MessageBox.Show("Unable to store current position.\n" + exc.ToString() + exc.StackTrace);
                }
            }
        }

        // fill tilesDirs 
        private void fillLayerNames()
        {
            ArrayList layers = tilesRepository.getLayers();

            // remove old values
            foreach (MenuItem mi in tilesDirsMenuItems.Keys)
            {
                menuoptions.MenuItems.Remove(mi);
            }

            tilesDirsMenuItems = new Hashtable();
            foreach (LayerInfo li in layers)
            {
                MenuItem mi = new System.Windows.Forms.MenuItem();
                mi.Text = li.ServiceName + ": " + li.LayerName;
                menuoptions.MenuItems.Add(mi);
                mi.Click += new System.EventHandler(this.menuTilesDir_Click);

                tilesDirsMenuItems.Add(mi, li.TextID);
            }
        }

        private int tiles_on_level(int zoom)
        {
            return 1 << (ZOOM_MIN - zoom);
        }

        /*
         * latitude - (North / South)
         * longitude - (East / West)
         */
        private void GPScoord_to_plaincoord(double latitude, double longitude, int zoom, out int coordx, out int coordy)
        {
            int world_pixels = tiles_on_level(zoom) * tilesWidth;
            coordx = (int)Math.Round((world_pixels * (longitude + 180) / 360.0));

            double pixels_per_radian = world_pixels / (2 * Math.PI);
            double e = Math.Sin(latitude * (Math.PI / 180));
            coordy = (int)Math.Round((world_pixels / 2 + 0.5 * Math.Log((1 + e) / (1 - e)) * (-pixels_per_radian)));

        }

        private double GPSTileWidth_to_metres()
        {
            double lat, lon;
            GPSplaincoord_to_coord(coordX, coordY, zoom, out lat, out lon);

            // count the length of tile in coordY in meters
            
            //double metersInDegree = Meters * Math.PI * Math.Cos(lat * Math.PI / 180) / 180;
            return earths_average_meridional_radius * Math.Cos(lat * Math.PI / 180) * 2 * Math.PI / (double)tiles_on_level(zoom);
            //return metersInTile;
        }

        public void getCurrentCoordsGPS(out double latitude, out double longitude)
        {
            GPSplaincoord_to_coord(coordX, coordY, zoom, out latitude, out longitude);
        }

        public void GPSplaincoord_to_coord(int coordx, int coordy, int zoom, out double latitude, out double longitude)
        { 
            int worldPixels = tiles_on_level(zoom) * tilesWidth;
            double x = coordx * 2.0 / worldPixels - 1;
            double y = coordy * 2.0 / worldPixels - 1;

            longitude = x * 180;
            y = Math.Exp(-y * 2 * Math.PI);
            double e = (y-1)/(y+1);
            latitude = 180/Math.PI * Math.Asin(e);
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            //MessageBox.Show("Here we go!");
        }

        private void menuClose_Click(object sender, EventArgs e)
        {
            if (gps.Opened)
            {
                gps.DeviceStateChanged -= gps_DeviceStateChanged;
                gps.LocationChanged -= gps_LocationChanged;

                gps.Close();
            }

            if (tilesRepository.isInitialized())
            {
                writeMapPosition();
            }

            Close();
        }

        private Bitmap getTile( int lzoom, int ltilex, int ltiley )
        {
            string tileHash = tilesRepository.getReposID() + ":" + lzoom.ToString() + ":" + ltilex.ToString() + ":" + ltiley.ToString();

            if (tilesCache.ContainsKey(tileHash))
            {
                // use kay and set new timestamp for it
                long tstamp = DateTime.Now.ToFileTime();
                int idx = tilesTimestampCache.IndexOfValue(tileHash);
                tilesTimestampCache.RemoveAt(idx);
                // is my timestamp newer than timestamp in the array?
                if ((tilesTimestampCache.Count > 0) && (tstamp <= (long)tilesTimestampCache.GetKey(tilesTimestampCache.Count - 1)))
                {
                    tstamp = (long)tilesTimestampCache.GetKey(tilesTimestampCache.Count - 1) + 1;
                }
                tilesTimestampCache.Add(tstamp, tileHash);

                return (Bitmap)tilesCache[tileHash];
            }

            Bitmap btm;
            try
            {
                btm = tilesRepository.getTile(lzoom, ltilex, ltiley);

                if (tilesTimestampCache.Count >= tilesCacheSize)
                {
                    // tha cache is full - delete the tile used the least
                    String tileToRemove = (String)tilesTimestampCache.GetByIndex(0);
                    tilesTimestampCache.RemoveAt(0);
                    tilesCache.Remove(tileToRemove);
                }

                long tstamp = DateTime.Now.ToFileTime();
                // is my timestamp newer than the newest in the array?
                if ((tilesTimestampCache.Count > 0) && (tstamp <= (long)tilesTimestampCache.GetKey(tilesTimestampCache.Count - 1)))
                {
                    tstamp = (long)tilesTimestampCache.GetKey(tilesTimestampCache.Count - 1) + 1;
                }
                tilesTimestampCache.Add(tstamp, tileHash);
                tilesCache.Add(tileHash, btm);
            }
            catch (TileNotFoundException)
            {
                // that's OK
                btm = tileNotFound;
            }
            catch (RepositoryException e)
            {
                MessageBox.Show(e.ToString() + e.StackTrace);
                btm = tileNotFound;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString() + e.StackTrace);
                btm = tileNotFound;
            }


            return btm;
        }

        private void CoordToTileAndOffeset()
        {
            int coMajX, coMinX, coMajY, coMinY;

            int startX = coordX - dispWidth / 2;
            coMajX = startX / tilesWidth;
            coMinX = startX % tilesWidth;

            tilex = coMajX;
            ofsx = -1 * (coMinX);


            int startY = coordY - dispHeight / 2;
            coMajY = startY / tilesWidth;
            coMinY = startY % tilesWidth;

            tiley = coMajY;
            ofsy = -1 * (coMinY);


            return;
        }

        private void updatePositionGPSMark()
        {
            // view pictureboxGPS - GPS position marker
            if (flagGPSLongitudeValid && flagGPSLongitudeValid)
            {
                if (flagStickToGPSCoords)
                {
                    pictureBoxGPS.Left = (dispWidth >> 1) - pictureBoxGPSHalfWidth;
                    pictureBoxGPS.Top = (dispHeight >> 1) - pictureBoxGPSHalfHeight;
                    pictureBoxGPS.Visible = true;
                }
                else
                {
                    int dx, dy;

                    // dx = prepocitej na pozici stred screen + polovina sirky screen 
                    dx = ((gpsLatitudePix - coordX) << userzoombits) + (dispWidth >> 1);
                    dy = ((gpsLongitudePix - coordY) << userzoombits) + (dispHeight >> 1);
                    if (((dx - pictureBoxGPSHalfWidth) > 0 && (dx + pictureBoxGPSHalfWidth) < dispWidth) && 
                        ((dy - pictureBoxGPSHalfHeight) > 0 && (dy + pictureBoxGPSHalfHeight) < dispHeight))
                    {
                        pictureBoxGPS.Left = dx - pictureBoxGPSHalfWidth;
                        pictureBoxGPS.Top = dy - pictureBoxGPSHalfHeight;
                        pictureBoxGPS.Visible = true;
                    }
                    else
                    {
                        pictureBoxGPS.Visible = false;
                    }
                }
            }
        }

        private void drawWayPoints(Graphics g)
        {
            // do we have to draw wayPoints?
            if (!flagDrawWayPoints)
                return;

            foreach (WayPoint wp in waypoints)
            {

                bool drawMe = false;
                if (flagDrawAllWayPoints)
                {
                    drawMe = true;
                }
                else
                {
                    // recount only selected WPTypes
                    if (selectedWPTypes.IndexOf(wp.getWPType()) > -1)
                    {
                        drawMe = true;
                    }
                }

                if (!drawMe)
                {
                    continue;
                }

                if (wp.px > (coordX - (dispWidth >> (1 + userzoombits))) && wp.px < (coordX + (dispWidth >> (1 + userzoombits))) &&
                    wp.py > (coordY - (dispHeight >> (1 + userzoombits))) && wp.py < (coordY + (dispHeight >> (1 + userzoombits))))
                {
                    if (userzoom == 1)
                    {
                        // i can draw, draw
                        g.FillRectangle(new SolidBrush(wp.color), wp.px - coordX + dispWidth / 2 - wp.size / 2, wp.py - coordY + dispHeight / 2 - wp.size / 2, wp.size, wp.size);
                        // drow waypoint name
                        g.DrawString(wp.name, new Font("Arial", 9, System.Drawing.FontStyle.Bold), new SolidBrush(wp.color), wp.px - coordX + dispWidth / 2 + wp.size / 2 + 8, wp.py - coordY + dispHeight / 2 - 14);
                    }
                    else
                    {
                        //userzoom = 2
                        // i can draw, draw
                        g.FillRectangle(new SolidBrush(wp.color), userzoom * (wp.px - coordX + dispWidth / 2 - wp.size / 2) - dispWidth / userzoom, userzoom * (wp.py - coordY + dispHeight / 2 - wp.size / 2) - dispHeight / userzoom, wp.size * userzoom, wp.size * userzoom);
                        // drow waypoint name
                        g.DrawString(wp.name, new Font("Arial", 9, System.Drawing.FontStyle.Bold), new SolidBrush(wp.color), userzoom * (wp.px - coordX + dispWidth / 2 + wp.size / 2) - dispWidth / userzoom + 8, userzoom * (wp.py - coordY + dispHeight / 2) - dispHeight / userzoom - 14);
                    }
                }
            }
            
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            int countx = 0;
            int county = 0;

            // draw tiles
            Graphics g = e.Graphics;


            // draw to buffer
            if (!flagMovingTheMouse)
            {
                CoordToTileAndOffeset();
                Graphics gBuffer = Graphics.FromImage(bitmapBuffer);
                do
                {
                    // do horizontal tiles
                    do
                    {
                        Bitmap tle = getTile(zoom, tilex + countx, tiley + county);
                        gBuffer.DrawImage(tle, tilesWidth * countx + ofsx + dispWidth, tilesHeight * county + ofsy + dispHeight);
                        countx += 1;
                    } while ((countx * tilesWidth + ofsx) < pictureBox1.Width);

                    countx = 0;
                    county += 1;
                } while ((county * tilesHeight + ofsy) < pictureBox1.Height);
                gBuffer.Dispose();

                mouseDeltaX = 0;
                mouseDeltaY = 0;
            }

            // show buffer on screen
            if (userzoom == 1)
            {
                Rectangle srcRect = new Rectangle(dispWidth + mouseDeltaX, dispHeight + mouseDeltaY, dispWidth, dispHeight);
                g.DrawImage(bitmapBuffer, 0, 0, srcRect, GraphicsUnit.Pixel);
                
            }
            else
            {
                Rectangle dstRect = new Rectangle(0, 0, dispWidth, dispHeight);
                // userzoom = 2
                // dispWidth is divided by 4, I want to get quartre to the edge of the display
                // the same for dispHeight
                Rectangle srcRect = new Rectangle(dispWidth + (dispWidth >> 2) + (mouseDeltaX >> 1), dispHeight + (dispHeight >> 2) + (mouseDeltaY >> 1), (dispWidth >> 1), (dispHeight >> 1));
                g.DrawImage(bitmapBuffer, dstRect, srcRect, GraphicsUnit.Pixel);
            }


            // view other items - ruler, gps coords, waypoints
            if (!flagMovingTheMouse)
            {

                updatePositionGPSMark();

                int rulerSize = (int)Math.Round(GPSTileWidth_to_metres());
                if (bLowResDisplay)
                {
                    rulerSize = rulerSize >> (userzoombits + 1);
                }
                else
                {
                    rulerSize = rulerSize >> userzoombits;
                }
                // view ruler
                g.FillRectangle(new SolidBrush(Color.Red), 5, 16, rulerWidth, 4);
                g.FillRectangle(new SolidBrush(Color.Black), 5, 12, 2, 10);
                g.FillRectangle(new SolidBrush(Color.Black), 5 + (rulerWidth >> 1), 14, 2, 6);
                g.FillRectangle(new SolidBrush(Color.Black), 5 + rulerWidth, 12, 2, 10);
                g.DrawString(String.Concat(rulerSize.ToString(), " m"), new Font("Arial", 10, System.Drawing.FontStyle.Bold), new SolidBrush(Color.Red), 5 + rulerWidth + 10, 2);


                // view crosshair for showGPSCoords
                g.FillRectangle(new SolidBrush(Color.DarkRed), (dispWidth >> 1) - 3, (dispHeight >> 1), 7, 1);
                g.FillRectangle(new SolidBrush(Color.DarkRed), (dispWidth >> 1), (dispHeight >> 1) - 3, 1, 7);

                // view gps coords numbers
                if (flagShowGPSCoords)
                {
                    double lat, lon;
                    GPSplaincoord_to_coord(coordX, coordY, zoom, out lat, out lon);
                    lat = Math.Round(lat, 4);
                    lon = Math.Round(lon, 4);
                    string latid = lat.ToString() + ", ";
                    string longit = lon.ToString();
                    g.DrawString(latid, new Font("Arial", 10, System.Drawing.FontStyle.Bold), new SolidBrush(Color.Red), (dispWidth >> 1) + 8, (dispHeight >> 1) - 13);
                    g.DrawString(longit, new Font("Arial", 10, System.Drawing.FontStyle.Bold), new SolidBrush(Color.Red), (dispWidth >> 1) + 8, (dispHeight >> 1) + 13);
                    // string latlon = lat.ToString() + ", " + lon.ToString();
                    //g.DrawString(latlon, new Font("Arial", 10, System.Drawing.FontStyle.Bold), new SolidBrush(Color.Red), (dispWidth >> 1) + 8, (dispHeight >> 1) - 13);
                }


                // draw wayPoints
                drawWayPoints(g);
            }



            if (drawMouseCoord)
            {
                g.FillRectangle(new SolidBrush(Color.White), new Rectangle(0, 0, 200, 200));
                //string outStr = String.Concat("l:",left.ToString(),":t:",top.ToString(),":w:",width.ToString(),":h:",height.ToString());
                string outStr = String.Concat("mPX:", mousePosX.ToString(), ": mPY:", mousePosY.ToString(), ": mDX:", mouseDeltaX.ToString(), ": mDY:", mouseDeltaY.ToString());
                g.DrawString(outStr,
                    new Font("Arial", 10, FontStyle.Regular), new System.Drawing.SolidBrush(Color.Black), new RectangleF(0, 0, 200, 100));

                drawMouseCoord = false;
            }

            // e.ClipRectangle : Rectangle
            // e.Graphics : Graphics

            // TODO: g.Dispose(); ma byt tohle??
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            mouseDeltaX = mousePosX - e.X;
            mouseDeltaY = mousePosY - e.Y;

            flagMovingTheMouse = true;
            pictureBoxGPS.Visible = false; // while moving around, don't show GPS marker
            
            flagStickToGPSCoords = false;
            pictureBoxGPSchangeColor();
            
            pictureBox1.Invalidate();
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            mousePosX = e.X;
            mousePosY = e.Y;

            //System.Console.WriteLine("mouseDown");
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            mouseDeltaX = mousePosX - e.X;
            mouseDeltaY = mousePosY - e.Y;
            coordX += mouseDeltaX / userzoom;   // to je divne. userzoom se pouziva tady a v onPain. Melo by to byt jen na jedinem miste
            coordY += mouseDeltaY / userzoom;

            if (flagPictureBox1Click)
            {
                // clicked point should be moved to the middle of the display
                // click: e.X, e.Y (0 - dispWidth, 0 - dispHeight)
                // old middle point = dispWidth / 2; dispHeight / 2 ~ coordX, coordY
                // new middle point: delta = e.X - dispWidth / 2
                if (Math.Abs(mouseDeltaX) < 10 && Math.Abs(mouseDeltaY) < 10)
                {
                    coordX += (e.X - dispWidth / 2) / userzoom;   // to je divne. userzoom se pouziva tady a v onPain. Melo by to byt jen na jedinem miste
                    coordY += (e.Y - dispHeight / 2) / userzoom;
                }
                flagPictureBox1Click = false;
            }
            /*
            mousePosX = e.X;
            mousePosY = e.Y;
             */
            //drawMouseCoord = true;
            flagMovingTheMouse = false;
            pictureBox1.Invalidate();

            //System.Console.WriteLine("mouseUp");

        }

        private void incrementZoom()
        {
            // zoom in
            zoom--;
            coordX <<= 1;
            coordY <<= 1;
        }
        private void decrementZoom()
        {
            // zoom out
            zoom++;
            coordX >>= 1;
            coordY >>= 1;
        }

        private void setbplusminusLabels()
        {
            int v;
            v = zoom - 1;
            bplus.Text = zoom.ToString() + "+";
            v = zoom + 1;
            bminus.Text = zoom.ToString() + "-";
        }

        private void recountWaypointsCoords()
        {
            if (flagDrawWayPoints)
            {
                foreach (WayPoint wp in waypoints)
                {
                    if (flagDrawAllWayPoints)
                    {
                        GPScoord_to_plaincoord(wp.latitude, wp.longitude, zoom, out wp.px, out wp.py);
                    }
                    else
                    {
                        // recount only selected WPTypes
                        if (selectedWPTypes.IndexOf(wp.getWPType()) > -1)
                        {
                            GPScoord_to_plaincoord(wp.latitude, wp.longitude, zoom, out wp.px, out wp.py);
                        }
                    }
                }
            }
        }

        private void recountGPSMarkCoords()
        {
            GPScoord_to_plaincoord(gpsLatitude, gpsLongitude, zoom, out gpsLatitudePix, out gpsLongitudePix);
        }

        private void bplus_Click(object sender, EventArgs e)
        {
            if (zoom > ZOOM_MAX)
            {
                //changeZoom(zoom - 1);
                incrementZoom();
            }
            setbplusminusLabels();
            recountWaypointsCoords();
            recountGPSMarkCoords();
            pictureBox1.Focus();
            pictureBox1.Invalidate();
        }

        private void bminus_Click(object sender, EventArgs e)
        {
            if (zoom < ZOOM_MIN)
            {
                //changeZoom(zoom + 1);
                decrementZoom();
            }

            setbplusminusLabels();
            recountWaypointsCoords();
            recountGPSMarkCoords();
            pictureBox1.Focus();
            pictureBox1.Invalidate();
        }

        private void buserzoom_Click(object sender, EventArgs e)
        {
            if (userzoom == 1)
            {
                userzoom = 2;
                userzoombits = 1;
                buserzoom.Text = "O";
            }
            else
            {
                userzoom = 1;
                userzoombits = 0;
                buserzoom.Text = "o";
            }
            pictureBox1.Focus();
            pictureBox1.Invalidate();
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            // go to the coords
            // order - set flag we have the click - is used in mouseUp
            // order: MDown, MMove, MClick, Mup
            flagPictureBox1Click = true;
        }

        private void gpsStickToMapChange()
        {
            if (flagGPSLongitudeValid && flagGPSLongitudeValid)
            {
                flagStickToGPSCoords = true;
                pictureBoxGPSchangeColor();
                setMainCoords(gpsLatitudePix, gpsLongitudePix);
                pictureBox1.Invalidate();
            }
            else
            {
                // hide the middle
                pictureBoxGPS.Visible = false;
                flagStickToGPSCoords = false;
                pictureBoxGPSchangeColor();
            }
            return;

        }

        private void bgps_Click(object sender, EventArgs e)
        {
            gpsStickToMapChange();
        }

        /*
            GPS stavy:
            - gps off: enable=false
            - gps on: enable = true

            StickToGPS:
            - blue

            Latitude&Longitude valid:
            - light blue

            else:
            - light gray
         */
        private void pictureBoxGPSchangeColor()
        {

            if (!bgps.Enabled)
            {
                bgps.BackColor = System.Drawing.Color.LightGray;
                return;
            }
            if (flagGPSLatitudeValid && flagGPSLongitudeValid)
            {
                if (flagStickToGPSCoords)
                {
                    bgps.BackColor = System.Drawing.Color.Blue;
                }
                else
                {
                    bgps.BackColor = System.Drawing.Color.LightBlue;
                }
            }
            else
            {
                bgps.BackColor = System.Drawing.Color.LightGray;
            }
            return;
        }

        void gps_LocationChanged(object sender, LocationChangedEventArgs args)
        {
            ControlUpdater cu = UpdateControl;
            ControlUpdaterGPS cugps = UpdateControlGPS;

            GpsPosition position = args.Position;

            if (position.LatitudeValid)
            {
                Invoke(cugps, 0, position.Latitude);
                Invoke(cu, tbLatitude, position.Latitude.ToString());
            }
            if (position.LongitudeValid) 
            {
                Invoke(cugps, 1, position.Longitude);
                Invoke(cu, tbLongitude, position.Longitude.ToString());
            }
            if (position.HeadingValid)
                Invoke(cu, tbHeading, position.Heading.ToString());
            if (position.SatellitesInViewCountValid)
                Invoke(cu, tbSatellites, position.SatellitesInViewCount.ToString());
        }

        void gps_DeviceStateChanged(object sender, DeviceStateChangedEventArgs args)
        {
            ControlUpdater cu = UpdateControl;

            GpsDeviceState device = args.DeviceState;

            Invoke(cu, tbGPSDevice, device.FriendlyName);
            Invoke(cu, tbGPSDeviceState, device.DeviceState.ToString());
            Invoke(cu, tbGPSServiceState, device.ServiceState.ToString());
        }

        private delegate void ControlUpdater(Control c, string s);
        private delegate void ControlUpdaterGPS(int latlong, double value);

        private void UpdateControl(Control c, string s)
        {
            c.Text = s;
        }

        private void UpdateControlGPS(int latlong, double value)
        {
            if (latlong == 0)
            {
                // latitude
                gpsLatitude = value;
                flagGPSLatitudeValid = true;
            }
            else
            {
                // longitude
                gpsLongitude = value;
                flagGPSLongitudeValid = true;
            }

            if (flagGPSLatitudeValid && flagGPSLongitudeValid)
            {
                pictureBoxGPSchangeColor();
                recountGPSMarkCoords();

                if (flagStickToGPSCoords)
                {
                    if ((Math.Round(Math.Sqrt((gpsLatitudePix - coordX) * (gpsLatitudePix - coordX) + (gpsLongitudePix - coordY) * (gpsLongitudePix - coordY))) > 2) || (pictureBoxGPS.Visible == false))
                    {
                        setMainCoords(gpsLatitudePix, gpsLongitudePix);
                        pictureBox1.Invalidate();
                    }
                }
                else
                {
                    updatePositionGPSMark();
                }
            }
        }

        private void setMainCoords(int x, int y)
        {
            coordX = x;
            coordY = y;
        }

        // it's general handler when tiles directory is changed in the menu
        private void menuTilesDir_Click(object sender, EventArgs e)
        {
            //setTilesDir(((MenuItem)sender).Text.Substring(TILES_DIR_MENU_PREFIX.Length));
            string textID = (string)tilesDirsMenuItems[(MenuItem)sender];
            tilesRepository.setTilesLayer(textID);
            pictureBox1.Invalidate();
        }


        private void menugps_Click(object sender, EventArgs e)
        {

            if (!gps.Opened)
            {
                gps.DeviceStateChanged += new DeviceStateChangedEventHandler(gps_DeviceStateChanged);
                gps.LocationChanged += new LocationChangedEventHandler(gps_LocationChanged);
                gps.Open();

                bgps.Enabled = true;
                pictureBoxGPSchangeColor();
            }
            else
            {
                gps.Close();
                gps.DeviceStateChanged -= gps_DeviceStateChanged;
                gps.LocationChanged -= gps_LocationChanged;
                
                tbGPSDevice.Text = "";
                tbGPSDeviceState.Text = "";
                tbGPSServiceState.Text = "";
                tbHeading.Text = "";
                tbLatitude.Text = "";
                tbLongitude.Text = "";
                tbSatellites.Text = "";

                bgps.Enabled = false;
                flagGPSLatitudeValid = false;
                flagGPSLongitudeValid = false;
                pictureBoxGPSchangeColor();
                pictureBoxGPS.Visible = false;
            }
            menugps.Text = gps.Opened ? "Switch GPS Off" : "Switch GPS On";
        }

        private void bgpspanelswitch_Click(object sender, EventArgs e)
        {
            // hide and show gps panel
            if (panelGPSDetails.Visible)
            {
                panelGPSDetails.Visible = false;
                //menugps.Text = "Switch GPS On";
            }
            else
            {
                panelGPSDetails.Visible = true;
                //menugps.Text = "Switch GPS Off";
            }
        }

        private void form1_KeyDown(object sender, KeyEventArgs e)
        {

        }

        private void swith_display_orientation()
        {
            if (SystemSettings.ScreenOrientation == ScreenOrientation.Angle0)
            {
                SystemSettings.ScreenOrientation = ScreenOrientation.Angle270;
            }
            else
            {
                SystemSettings.ScreenOrientation = ScreenOrientation.Angle0;
            }
            initScreenDimensions();
            pictureBox1.Invalidate();
        }

        private void menuScreenOrientation_Click(object sender, EventArgs e)
        {
            swith_display_orientation();
        }

        private void form1_Activated(object sender, EventArgs e)
        {
            orientationAtApplicationStart = SystemSettings.ScreenOrientation;
        }

        private void form1_Deactivate(object sender, EventArgs e)
        {
            SystemSettings.ScreenOrientation = orientationAtApplicationStart;
        }

        private bool show_dialog_select_map_dir()
        {
            ScreenOrientation so = SystemSettings.ScreenOrientation;
            SystemSettings.ScreenOrientation = ScreenOrientation.Angle0;
            initScreenDimensions();
            pictureBox1.Invalidate();

            FormSelectMap fs = new FormSelectMap(this);
            fs.ShowDialog();

            if (!fs.IsSelectedMap)
            {
                SystemSettings.ScreenOrientation = so;
                initScreenDimensions();
                pictureBox1.Invalidate();
                return false;
            }


            if (mapDirsCurrent == null || !mapDirsCurrent.Equals(fs.SelectedMap))
            {
                if (flagStickToGPSCoords)
                {
                    gpsStickToMapChange();
                }
                this.Text = mapDirsCurrent;
                if (tilesRepository.isInitialized())
                {
                    writeMapPosition();
                }
                mapDirsCurrent = fs.SelectedMap;
                initMap();
            }
            SystemSettings.ScreenOrientation = so;
            initScreenDimensions();
            pictureBox1.Invalidate();
            return true;
        }

        private void saveNewWayPoint(string type, string name, string note, string lat, string lon, string color, string tstamp)
        {
            string dirpath = getSelectedMapPath();
            string filepath = String.Concat(dirpath + "\\" + fileWayPoints);

            if (Directory.Exists(dirpath))
            {
                try
                {
                    bool exists = false;
                    if (File.Exists(filepath))
                    {
                        exists = true;
                    }

                    using (StreamWriter outfile = new StreamWriter(filepath, true))
                    {
                        // format of stored waypoint: ("gps:", type, ":",latitude.ToString(), ":", longitude.ToString(), ":", Timestamp, ":", Color, ":", wayPointName, ":", Note );
                        string pos;
                        if (!exists)
                        {
                            pos = "#gps:<type>:<latitude>:<longitude>:<timestamp>:<color>:<wayPointName>:<Note>";
                            outfile.Write(pos);
                        }
                        pos = "\r\ngps" + wayPointSep + type + wayPointSep + lat + wayPointSep + lon + wayPointSep + tstamp + wayPointSep + color + wayPointSep + name + wayPointSep + note;
                        outfile.Write(pos);
                    }
                }
                catch (Exception exc)
                {
                    MessageBox.Show("Unable to create waypoints file.\n" + exc.ToString() + exc.StackTrace);
                }
            }
        }

        private bool show_dialog_store_waypoint()
        {
            ScreenOrientation so = SystemSettings.ScreenOrientation;
            SystemSettings.ScreenOrientation = ScreenOrientation.Angle0;
            initScreenDimensions();
            pictureBox1.Invalidate();

            FormStoreWaypoint fw = new FormStoreWaypoint(this);

            fw.ShowDialog();

            if (fw.isSave())
            {
                saveNewWayPoint(fw.getWPType(), fw.getName(), fw.getNote(), fw.getLat(), fw.getLon(), fw.getColor(), fw.getTStamp());
                readStoredWayPoints();
            }

            SystemSettings.ScreenOrientation = so;
            initScreenDimensions();
            pictureBox1.Invalidate();
            return true;
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            show_dialog_select_map_dir();
        }

        private void menuwps_Click(object sender, EventArgs e)
        {
            show_dialog_store_waypoint();
        }

        private void menuShowGPSCoords_Click(object sender, EventArgs e)
        {
            if (flagShowGPSCoords)
            {
                flagShowGPSCoords = false;
                menuShowGPSCoords.Text = "Show GPS coords";
            }
            else
            {
                flagShowGPSCoords = true;
                menuShowGPSCoords.Text = "Hide GPS coords";
            }
            pictureBox1.Invalidate();
        }

        public string getSelectedWPTypes()
        {
            return selectedWPTypes;
        }

        public string getAllWPTypes()
        {
            return allWPTypes;
        }

        public string getDefaultWPType()
        {
            return defaultWPType;
        }

        public int getMainFormWidth()
        {
            return pictureBox1.Width;
        }
        public int getMainFormHeight()
        {
            return pictureBox1.Height;
        }

        public bool isFlagDrawWayPoints()
        {
            return flagDrawWayPoints;
        }
        public bool isFlagDrawAllWayPoints()
        {
            return flagDrawAllWayPoints;
        }


        private void show_dialog_view_waypoints_ok(FormSelectDisplayWP fw)
        {
            if (fw.isNoneSelected())
            {
                flagDrawWayPoints = false;
            }
            else if (fw.isAllSelected())
            {
                flagDrawWayPoints = true;
                flagDrawAllWayPoints = true;
            }
            else
            {
                flagDrawWayPoints = true;
                flagDrawAllWayPoints = false;
                selectedWPTypes = fw.getSelectedWPTypes();
            }

            recountWaypointsCoords();
            pictureBox1.Invalidate();
        }

        private void show_dialog_view_waypoints_go(FormSelectDisplayWP fw)
        {
            WayPoint vp = fw.get_selected_waypoint_for_go();
            if (vp != null)
            {
                GPScoord_to_plaincoord(vp.getLatitude(), vp.getLongitude(), zoom, out coordX, out coordY);
            }
        }

        private void show_dialog_view_waypoints()
        {
            ScreenOrientation so = SystemSettings.ScreenOrientation;
            SystemSettings.ScreenOrientation = ScreenOrientation.Angle0;
            initScreenDimensions();
            pictureBox1.Invalidate();

            FormSelectDisplayWP fw = new FormSelectDisplayWP(this);
            fw.ShowDialog();

            show_dialog_view_waypoints_ok(fw);
            if (fw.is_finished_go())
            {
                show_dialog_view_waypoints_go(fw);
            }

            SystemSettings.ScreenOrientation = so;
            initScreenDimensions();
            pictureBox1.Invalidate();

        }

        private void bshowwaypoints_Click(object sender, EventArgs e)
        {
            show_dialog_view_waypoints();
        }

        public ArrayList get_waypoints()
        {
            return waypoints;
        }

    }



}